#coding=utf-8
from django.db import models
from django.contrib.auth.models import User, AnonymousUser
from django.utils.translation import ugettext as _
from django.db.models import Q, F, get_model, Count
from storage import ImageStorage,FileStorage,ThumbStorage
UPLOAD_TO='./upload/%Y%m/%d'
class UserImages(models.Model):
    user = models.ForeignKey(User, verbose_name=_(u"当前用户"), related_name="userimages")
    picture = models.ImageField(verbose_name=_(u'图片'), max_length=250,
                                     upload_to=UPLOAD_TO,
                                     storage=ImageStorage(),
                                     null=True, blank=True)
    thumb = models.ImageField(verbose_name=_(u'缩略图'), max_length=250,
                                     upload_to=UPLOAD_TO,
                                     storage=ThumbStorage(),
                                     null=True, blank=True)
    afile = models.FileField(verbose_name=_(u"文件[不超过%sM,只能是rar、zip、swf类型]" % MAX_FILE_SIZE), 
                                     max_length=200,
                                     upload_to=UPLOAD_TO,
                                     storage=FileStorage())                                 
    
    def __unicode__(self):
        return u"%s" % self.user
    
    class Meta:
        verbose_name = _(u'个人图片文件夹')
        verbose_name_plural = verbose_name   
    
    def delete(self, using=None):
        try:
            self.picture.storage.delete(self.picture.name)
            self.thumb.storage.delete(self.thumb.name)
        except Exception, e:
            pass
        super(UserImages, self).delete(using=using)
